#pragma once

// STD/STL
#include <memory>

// ArmarX
#include <RobotAPI/libraries/aron/core/data/variant/complex/NDArray.h>

namespace armarx::armem::server::ltm
{
    class ImageConverter;
    using ImageConverterPtr = std::shared_ptr<ImageConverter>;

    class ImageConverter
    {
    public:
        enum class ConverterType
        {
            Str,
            Binary
        };

        ImageConverter(const ConverterType t, const std::string& s):
            type(t),
            suffix(s)
        {}
        virtual ~ImageConverter() = default;

        virtual std::vector<unsigned char> convert(const aron::data::NDArrayPtr& data) = 0;
        virtual aron::data::NDArrayPtr convert(const std::vector<unsigned char>& data) = 0;

        const ConverterType type;
        const std::string suffix;
    };
}
