#pragma once

// STD/STL
#include <mutex>
#include <string>

// BaseClass
#include <RobotAPI/libraries/armem/server/segment/Segment.h>

// ArmarX
#include <RobotAPI/libraries/armem_motions/aron/MDBReference.aron.generated.h>
#include <RobotAPI/libraries/armem_mps/aron/Trajectory.aron.generated.h>

namespace armarx::armem::mps
{
    class MPSegment : public armem::server::segment::wm::AronTypedProviderSegmentBase<armarx::armem::arondto::Trajectory>
    {
        using Base = armem::server::segment::wm::AronTypedProviderSegmentBase<armarx::armem::arondto::Trajectory>;

    public:
        MPSegment(armem::server::MemoryToIceAdapter& iceMemory);

        virtual void defineProperties(armarx::PropertyDefinitionsPtr defs, const std::string& prefix = "") override;
        virtual void onInit() override;
        virtual void onConnect();

    private:
        int loadByMotionFinder(const std::string&);
        void loadSingleMotionFinder(const std::string&, const std::string &entityName, bool taskspace);

    private:
        struct Properties
        {
            std::string motionsPackage = "PriorKnowledgeData";
            bool loadFromMotionsPackage = true;
        };
        Properties p;
    };
}
