#pragma once

// STD/STL
#include <memory>
#include <string>
#include <numeric>

// Memory
#include <RobotAPI/libraries/aron/core/data/variant/All.h>

#include <RobotAPI/libraries/aron/core/data/converter/variant/VariantConverter.h>
#include <RobotAPI/libraries/aron/core/data/converter/nlohmannJSON/NlohmannJSONConverter.h>
#include <RobotAPI/libraries/aron/core/data/rw/reader/variant/VariantReader.h>
#include <RobotAPI/libraries/aron/core/data/rw/writer/variant/VariantWriter.h>
#include <RobotAPI/libraries/aron/core/data/rw/reader/nlohmannJSON/NlohmannJSONReader.h>
#include <RobotAPI/libraries/aron/core/data/rw/writer/nlohmannJSON/NlohmannJSONWriter.h>

// JSON
#include <SimoxUtility/json/json.hpp>

namespace armarx::aron::converter
{
    class AronNlohmannJSONConverter
    {
    private:
        struct Variant2NlohmannJSONConverterHelper :
                public data::VariantConverter<data::writer::NlohmannJSONWriter, Variant2NlohmannJSONConverterHelper>
        {
        };

        struct NlohmannJSON2VariantConverterHelper :
                public data::NlohmannJSONConverter<data::writer::VariantWriter, NlohmannJSON2VariantConverterHelper>
        {
        };

    public:
        AronNlohmannJSONConverter() = delete;

        static nlohmann::json ConvertToNlohmannJSON(const data::VariantPtr&);
        static void ConvertToNlohmannJSON(const data::VariantPtr&, nlohmann::json&);

        static data::DictPtr ConvertFromNlohmannJSONObject(const nlohmann::json&);
        static void ConvertFromNlohmannJSON(data::VariantPtr&, const nlohmann::json&, const aron::type::VariantPtr& = nullptr);
    };
}
